package ${domain}.module.${moduleName}.mpr;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import ${domain}.frame.auth.Token;
import ${domain}.module.${moduleName}.ent.${table.getCName()};
<#if table.getFind()>
import ${domain}.module.${moduleName}.req.${table.getCName()}FindRequest;
</#if>
<#if table.getSearch()>
import ${domain}.module.${moduleName}.req.${table.getCName()}SearchRequest;
</#if>

import java.util.List;

/**
 * ${table.tableName} - ${table.tableComment}
 *
 * @author ${author?default("")}
 * @since ${.now?string["yyyy-MM-dd"]}
 */
@Mapper
public interface ${table.getCName()}Mapper {

    /**
     * 插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long insert(@Param("request") ${table.getCName()} request, @Param("token") Token token);

    /**
     * 批量插入
     *
     * @param list  对象集合
     * @param token 令牌
     * @return 返回数量
     */
    long insertBatch(@Param("list") List<${table.getCName()}> list, @Param("token") Token token);

    /**
     * 逻辑删除
     *
     * @param id    主键
     * @param token 令牌
     * @return 返回数量
     */
    long delete(@Param("id") Long id, @Param("token") Token token);

    /**
     * 批量逻辑删除
     *
     * @param list  主键集合
     * @param token 令牌
     * @return 返回数量
     */
    long deleteBatch(@Param("list") List<Long> list, @Param("token") Token token);

    /**
     * 更新
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long update(@Param("request") ${table.getCName()} request, @Param("token") Token token);

    /**
     * 普通查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
     List<${table.getCName()}> select(@Param("request") ${table.getCName()} request, @Param("token") Token token);
<#if table.getFind()>

    /**
     * 高级查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<${table.getCName()}> find(@Param("request") ${table.getCName()}FindRequest request, @Param("token") Token token);
</#if>
<#if table.getSearch()>

    /**
     * 模糊查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<${table.getCName()}> search(@Param("request") ${table.getCName()}SearchRequest request, @Param("token") Token token);
</#if>

    /**
     * 获得对象
     *
     * @param id    主键
     * @param token 令牌
     * @return 返回对象
     */
    ${table.getCName()} getById(@Param("id") Long id, @Param("token") Token token);

    /**
     * 获得对象
     *
     * @param list  主键集合
     * @param token 令牌
     * @return 返回对象
     */
    List<${table.getCName()}> getByIds(@Param("list") List<Long> list, @Param("token") Token token);
}
